<?php defined('SYSPATH') or die('No direct script access.');
  
class Model_Student extends Model
{
    private $id;

    public static function load($id) {
        $student = new self();
        $student->id = (int) $id;

        // todo: there should be a function to load data from db
        //    Student_Get(id): array

        return $student;
    }

    /**
     * Create new student from a source data.
     *
     * todo: no activation code (move the check to a controller)
     * todo: make Student_Create instead of CreateStudent
     * todo: test me
     *
     * @param $lastName
     * @param $firstName
     * @param $secondName
     * @param $gradeID
     * @param $activationCode
     * @return $this;
     */
    public static function create($lastName, $firstName, $secondName, $gradeID, $activationCode) {
        $sql = 'SELECT `CreateStudent`(:last, :first, :second, :grade, :code)';

        $id = DB::query(Database::SELECT, $sql)
            ->parameters([
                'last' => $lastName,
                'first' => $firstName,
                'second' => $secondName,
                'grade' => $gradeID,
                'code' => $activationCode,
            ])
            ->execute();

        return self::load($id);
    }


    // getters and setters
    function __get($name) {
        if ($name == 'id')
            return (int) $this->id;
        return null;
    }

    function __set($name, $value) { }

    // todo implementation
    public function update() {
        throw new BadMethodCallException('Method is not implemented yet!');
    }

    /**
     * @see students_groups.IsStudyLeave
     * @deprecated cause it's not implemented yet
     * @return boolean true, if the student is on leave
     */
    public function inAcademicLeave() {
        throw new BadMethodCallException("Method is not implemented yet!");
    }

    /**
     * Send the student to an academic leave.
     * @return $this;
     */
    public function toAcademicLeave() {
        $sql = "CALL `ControlStudentGroup`(:id, -1, true);";

        DB::query(Database::SELECT, $sql)
            ->param(':id', $this->id)
            ->execute();

        return $this;
    }

    /**
     * Cancel the student's leave.
     * @param $group int  group id
     * @return $this;
     */
    public function returnFromAcademicLeave($group) {
        $sql = "CALL `ControlStudentGroup`(:id, :group, false);";

        DB::query(Database::SELECT, $sql)
            ->param(':id', $this->id)
            ->param(':group', (int) $group)
            ->execute();

        return $this;
    }
}
